QGIS Application - Bug report #16891
$rownum returns 0 in field calculator
2017-07-19 01:47 PM-AL

Status: Closed

Priority: High

Assignee:

Category: Field calculator

Affected QGIS version:2.18.11 Regression?: Yes
Operating System: Windows 7 32bits Easy fix?: No
Pull Request or Patch supplied: Resolution: invalid
Crashes QGIS or corrupls data: Copied to github as #: 24790
Description

In QGIS 2.18.10, the $rownum function allways returns 0 in the field calculator.

As per #12174, it should return 0 in the expression field, but not in the field calculator.
Furthermore, the preview shows 1.

Is this some kind of regression ?

History

#1 - 2017-07-19 06:41 PM - Giovanni Manghi
- Status changed from Open to Feedback
- Priority changed from Normal to High

| just tested and does now happen here on Linux and Win7 with QGIS 2.18.10. Does it happen with any data of yours? tried without 3rd party plugins?

#2 - 2017-07-19 10:08 PM - A L
| tried on at least two different layers, but both where postgis layers.
The weird part that might give you a clue : the $rownum function is not in the functions list under "record". It's not in the list at all in fact. It is not shown in red
though, so it is somehow recognized.
How do you try without third party plug-ins? Is there some kind of safe mode? (sorry, new user here)
#3 - 2017-07-20 12:00 PM - Giovanni Manghi
A L wrote:
| tried on at least two different layers, but both where postgis layers.
The weird part that might give you a clue : the $rownum function is not in the functions list under "record". It's not in the list at all in fact. It is not
shown in red though, so it is somehow recognized.
How do you try without third party plug-ins? Is there some kind of safe mode? (sorry, new user here)
just tried with PostGIS layers on both Linxu and Windows and 2.18.10, works as expected (and starts from 1).

To start without plugins

qgis --noplugins
#4 - 2017-07-25 07:44 PM - Giovanni Manghi
- Affected QGIS version changed from 2.18.10 to 2.18.11

#5 - 2017-08-07 01:52 PM - A L

OK, | tried without plugins and it still doesn't work.

| almost got it to work when | created a "real" field instead of a "virtual field" in the fiels calculator.

Then the layer went into edit mode, and the new field was correctly computed and displayed. Of course, trying to exit edit mode did not work, since QGis
tried to save the changes to the PostGIS layer, which it could obiviously not do.

If 1 do the exact same thing with a virtual field, it does not work at all.

I still find it very weird that | do not have a "$rownum"” function in the functions list :
http://i.imgur.com/KiYmKeA.png

#6 - 2017-08-07 02:51 PM - Giovanni Manghi
- File Screenshot 20170807 _134950.png added

A L wrote:

OK, | tried without plugins and it still doesn't work.

I almost got it to work when | created a "real" field instead of a "virtual field" in the fiels calculator.

Then the layer went into edit mode, and the new field was correctly computed and displayed. Of course, trying to exit edit mode did not work, since
QGis tried to save the changes to the PostGIS layer, which it could obiviously not do.

If | do the exact same thing with a virtual field, it does not work at all.

1 still find it very weird that I do not have a "$rownum" function in the functions list :
http://i.imgur.com/KiYmKeA.png

see attached image. The fact you are finding issues with this and not seeing the $row_num function suggests you have local issues. Try do cleanup

(remove the .qgis2 folder, remove qgis registry entries) and try again.

#7 - 2017-08-07 03:57 PM - Nyall Dawson

Rownum is not available in virtual fields - that's why it's not shown in the expression builder when creating a virtual field.

#8 - 2017-08-07 05:26 PM - A L

The fact you are finding issues with this and not seeing the $row_num function suggests you have local issues. Try do cleanup (remove the .qgis2

folder, remove qgis registry entries) and try again.

| did that and installed the latest 2.18.11. No change.

Rownum is not available in virtual fields - that's why it's not shown in the expression builder when creating a virtual field.

| tried with a regular field and it's not shown either.

| also tried on a shapefile layer and it's still not there.
My PostGIS layer is a view, not a table, so a regular field does not work. That's where my problem is obviously. | need some way to add a unique id field to

aread-only layer.

#9 - 2017-08-08 08:21 AM - Nyall Dawson

Try $id instead of rownum. Regardless of the data source, rownum is not available in virtual fields.

#10 - 2017-08-08 10:57 AM - AL
Yes, | already tried that, but $id does not work very well when you filter the layer (i.e. not starting at 1, and holes in the series).

I'm a bit surprised that there is not such a function in QGis, since it is quite standard to have numbers on the map and the corresponding description in the

legend. That is what one can find on any web map that displays retail stores of a specific brand for instance.

#11 - 2017-09-25 04:26 PM - Giovanni Manghi
- Resolution set to invalid
- Status changed from Feedback to Closed
A L wrote:
Yes, | already tried that, but $id does not work very well when you filter the layer (i.e. not starting at 1, and holes in the series).

I'm a bit surprised that there is not such a function in QGis, since it is quite standard to have numbers on the map and the corresponding description

in the legend. That is what one can find on any web map that displays retail stores of a specific brand for instance.

Please file a feature request instead. Cheers!

Files
